VERSION 5.00
Begin VB.Form frmWinFrame 
   BorderStyle     =   0  'None
   Caption         =   "SkinWindow"
   ClientHeight    =   3345
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9300
   Icon            =   "frmWinFrame.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   223
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   620
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmWinFrame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim gdiPlusToken As Long

Implements ISubclass
Private m_emr As EMsgResponse

Private Sub Form_Initialize()
    Dim rt As rect
    GetWindowRect hwnd, rt
    SetWindowPos frmWin.hwnd, hwnd, rt.Left, rt.Top, rt.Right - rt.Left, rt.Bottom - rt.Top, SWP_NOZORDER Or SWP_NOACTIVATE Or SWP_NOSENDCHANGING
End Sub

Private Sub Form_Load()
   
   Dim GpInput As GdiplusStartupInput
   GpInput.GdiplusVersion = 1
   If GdiplusStartup(gdiPlusToken, GpInput) <> Ok Then
      MsgBox "Error loading GDI+!", vbCritical
      Unload Me
   End If
   
   LoadPNGSkin App.path & "\Skin.png"
    
   AttachMessages

End Sub

Private Function LoadPNGSkin(pngPath As String) As Boolean

    Dim selfClass As Long
    
    Dim tempBI As BITMAPINFO
    Dim lngHeight As Long
    Dim lngWidth As Long
    Dim curWinLong As Long
    Dim img As Long
    Dim graphics As Long
    Dim mDC As Long
    Dim mainBitmap As Long
    Dim oldBitmap As Long
    Dim srcPoint As POINTAPI
    Dim winSize As Size
    Dim blendFunc32bpp As BLENDFUNCTION
   
    Dim brush As Long
    Dim fontFam As Long, curFont As Long
    Dim rcLayout As RECTF
   
   With tempBI.bmiHeader
       .biSize = Len(tempBI.bmiHeader)
       .biBitCount = 32
       .biHeight = ScaleHeight
       .biWidth = ScaleWidth
       .biPlanes = 1
       .biSizeImage = .biWidth * .biHeight * (.biBitCount / 8)
   End With
       mDC = CreateCompatibleDC(hdc)
       mainBitmap = CreateDIBSection(mDC, tempBI, DIB_RGB_COLORS, ByVal 0, 0, 0)
       oldBitmap = SelectObject(mDC, mainBitmap)
       Call GdipCreateFromHDC(mDC, graphics)
       Call GdipLoadImageFromFile(StrConv(pngPath, vbUnicode), img)
       Call GdipGetImageHeight(img, lngHeight)
       Call GdipGetImageWidth(img, lngWidth)
       Call GdipDrawImageRect(graphics, img, 0, 0, lngWidth, lngHeight)
       
       curWinLong = GetWindowLong(hwnd, GWL_EXSTYLE)
       curWinLong = WS_POPUP Or WS_VISIBLE
       SetWindowLong hwnd, GWL_STYLE, curWinLong
       'curWinLong = WS_EX_LAYERED Or WS_EX_TRANSPARENT Or WS_EX_TOPMOST Or WS_EX_TOOLWINDOW
       curWinLong = WS_EX_LAYERED Or WS_EX_TOPMOST Or WS_EX_TOOLWINDOW
       SetWindowLong hwnd, GWL_EXSTYLE, curWinLong Or WS_EX_LAYERED
       SetWindowPos hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_NOZORDER
       srcPoint.x = 0
       srcPoint.y = 0
       winSize.cx = ScaleWidth
       winSize.cy = ScaleHeight
   With blendFunc32bpp
       .AlphaFormat = AC_SRC_ALPHA
       .BlendFlags = 0
       .BlendOp = AC_SRC_OVER
       .SourceConstantAlpha = 255
   End With
    Call GdipDisposeImage(img)
    Call GdipDeleteGraphics(graphics)
    Call UpdateLayeredWindow(hwnd, hdc, ByVal 0&, winSize, mDC, srcPoint, 0, blendFunc32bpp, ULW_ALPHA)

End Function

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
   If Button = 1 Then FormMove hwnd
End Sub

Private Sub AttachMessages()
   AttachMessage Me, Me.hwnd, WM_WINDOWPOSCHANGED
   AttachMessage Me, Me.hwnd, WM_ENTERSIZEMOVE
   AttachMessage Me, Me.hwnd, WM_EXITSIZEMOVE
   AttachMessage Me, Me.hwnd, WM_DESTROY
   AttachMessage Me, Me.hwnd, WM_ACTIVATE
   AttachMessage Me, Me.hwnd, WM_SIZE
   AttachMessage Me, Me.hwnd, WM_SIZING
   AttachMessage Me, Me.hwnd, WM_MOVE
   AttachMessage Me, Me.hwnd, WM_MOVING
   AttachMessage Me, Me.hwnd, WM_MOUSEACTIVATE
End Sub

Private Sub DetachMessages()
   DetachMessage Me, Me.hwnd, WM_WINDOWPOSCHANGED
   DetachMessage Me, Me.hwnd, WM_ENTERSIZEMOVE
   DetachMessage Me, Me.hwnd, WM_EXITSIZEMOVE
   DetachMessage Me, Me.hwnd, WM_DESTROY
   DetachMessage Me, Me.hwnd, WM_ACTIVATE
   DetachMessage Me, Me.hwnd, WM_SIZE
   DetachMessage Me, Me.hwnd, WM_SIZING
   DetachMessage Me, Me.hwnd, WM_MOVE
   DetachMessage Me, Me.hwnd, WM_MOVING
   DetachMessage Me, Me.hwnd, WM_MOUSEACTIVATE
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    DetachMessages
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call GdiplusShutdown(gdiPlusToken)
End Sub

Private Property Let ISubclass_MsgResponse(ByVal RHS As EMsgResponse)
    m_emr = RHS
End Property

Private Property Get ISubclass_MsgResponse() As EMsgResponse
    m_emr = emrConsume
    ISubclass_MsgResponse = m_emr
End Property

Private Function ISubclass_WindowProc(ByVal hwnd As Long, ByVal iMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

    Dim curPos As WINDOWPOS
    Dim rt As rect
    
   Select Case iMsg
    Case WM_WINDOWPOSCHANGED
      CopyMemory curPos, ByVal lParam, LenB(curPos)
      Call SetWindowPos(frmWin.hwnd, hwnd, curPos.x, curPos.y, curPos.cx, curPos.cy, SWP_NOZORDER Or SWP_NOOWNERZORDER Or SWP_NOACTIVATE Or SWP_NOSENDCHANGING)
    Case WM_ENTERSIZEMOVE, WM_EXITSIZEMOVE, WM_ACTIVATE, WM_MOUSEACTIVATE, WM_SIZE, WM_SIZING, WM_MOVE, WM_MOVING
      GetWindowRect hwnd, rt
      SetWindowPos frmWin.hwnd, HWND_TOP, rt.Left, rt.Top, rt.Right - rt.Left, rt.Bottom - rt.Top, SWP_SHOWWINDOW
      SetWindowPos frmWinFrame.hwnd, hwnd, rt.Left, rt.Top, rt.Right - rt.Left, rt.Bottom - rt.Top, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER Or SWP_NOOWNERZORDER Or SWP_NOACTIVATE Or SWP_NOSENDCHANGING
      
    Case WM_DESTROY
      DetachMessages
      
   End Select
    
End Function



